<script setup lang="ts">
import type { Customer } from '@/types/Customer'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useMemberStore } from '@/stores/member'
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Point',
    key: 'point',
    value: 'point'
  },
  {
    title: 'Accumulate',
    key: 'accumulate',
    value: 'accumulate'
  },
  {
    title: 'Discount',
    key: 'discount',
    value: 'discount'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const loading = ref(false)
const dialogDelete = ref(false)
const initilCustomer: Customer = {
  id: -1,
  name: '',
  tel: '',
  point: 0,
  accumulate: 0,
  discount: 0
}
const editedCustomer = ref<Customer>(JSON.parse(JSON.stringify(initilCustomer)))
const customers = ref<Customer[]>([])
let editedIndex = -1
let lastId = 5
let lastPoint = 1
function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedCustomer.value = Object.assign({}, initilCustomer)
  })
}
function deleteItemConfirm() {
  // Delete item from list
  customers.value.splice(editedIndex, 1)
  closeDelete()
}
function editItem(item: Customer) {
  editedIndex = customers.value.indexOf(item)
  editedCustomer.value = Object.assign({}, item)
  dialog.value = true
}
function deleteItem(item: Customer) {
  editedIndex = customers.value.indexOf(item)
  editedCustomer.value = Object.assign({}, item)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedCustomer.value = Object.assign({}, initilCustomer)
    editedIndex = -1
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return

  if (editedIndex > -1) {
    Object.assign(customers.value[editedIndex], editedCustomer.value)
  } else {
    editedCustomer.value.id = lastId++
    editedCustomer.value.point = lastPoint++
    customers.value.push(editedCustomer.value)
  }

  editedIndex = -1
  closeDialog()
}
function initialize() {
  customers.value = [
    {
      id: 1,
      name: 'Mod Mod',
      tel: '0812345678',
      point: 50,
      accumulate: 60,
      discount: 10
    },
    {
      id: 2,
      name: 'Ja Ja',
      tel: '0823456789',
      point: 48,
      accumulate: 50,
      discount: 5
    },
    {
      id: 3,
      name: 'Poy Poy',
      tel: '0834567891',
      point: 29,
      accumulate: 30,
      discount: 0
    },
    {
      id: 4,
      name: 'Mild Mild',
      tel: '0845678912',
      point: 55,
      accumulate: 55,
      discount: 10
    }
  ]
}
onMounted(() => {
  initialize()
})
function searchfor(Input: string) {
  customers.value = customers.value.filter(function (customers) {
    return (
      customers.name.toLowerCase().includes(Input.toLowerCase()) || customers.tel.includes(Input)
    )
  })
}
const input = ref('')
function extra() {
  searchfor(input.value)
}
</script>
<template>
  <div class="app-container">
    <v-data-table :headers="headers" :items="customers">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(173, 105, 53)">
          <v-toolbar-title>Customer Member</v-toolbar-title>

          <v-text-field
            v-model="input"
            density="compact"
            variant="solo"
            label="Search Name/Phone number"
            append-inner-icon="mdi-magnify"
            single-line
            hide-details
            @click:append-inner="extra"
            @keyup.enter="extra()"
          ></v-text-field>
          <v-btn icon="mdi-cached" color="text-black" @click="initialize"></v-btn>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
                >New Member</v-btn
              >
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Customer Member</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedCustomer.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedCustomer.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Tel"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="editedCustomer.point"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Point"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>***indicates required field***</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">Close</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()">Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- </v-row> -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Delete?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">Yes</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)"
          >mdi-pencil</v-icon
        >
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)">mdi-delete</v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="initialize">Reset</v-btn>
      </template>
    </v-data-table>
  </div>
</template>

<style scoped>
.app-container {
  position: relative;
  height: 800px;
}

.app-container::before {
  content: '';
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  background: url('/cafe.png') no-repeat center center fixed;
  background-size: cover;
  opacity: 0.7;
  z-index: -1;
  /* ตั้งค่า z-index เพื่อให้ pseudo-element อยู่หลัง content ภายใน .app-container */
}
</style>
